// WavDataIn.h: interface for the WavDataIn class.
//
//////////////////////////////////////////////////////////////////////

#include "wavfile.h"

class WavDataIn : public WavFile  
{
public:
	WavDataIn();
	virtual ~WavDataIn();

	int open(char *, int, int, int);

    unsigned int decodeBits(int, int);
    unsigned int getNextBit();
	unsigned int getNextByte();

	int oneBitLength;
	int zeroBitLength;
    double midPoint;
 	bool passedZero();

protected:
	int	firstBit;
	unsigned char byteStream;
	double average;

	int getHalfWav(bool);
	double runningAverage(long currentVal);

private:
	int getWavLength(void);

	long midPointCount;
	long inPhase;
	int wavSign;
    int minHalfWavLength;
};
