#ifdef _AFXDLL
    #include "stdafx.h"
#endif
#include "WavDataOut.h"

WavDataOut::WavDataOut(void) {
    zeroBitLength = 7;
	oneBitLength = 14;
}

WavDataOut::~WavDataOut()
{
	close();
}

int WavDataOut::open(char *pFileName, long pSampleRate, int pBitsPerSample, int pChannels)
{
	bitcount = 0;
    return openOutput(pFileName, pSampleRate, pBitsPerSample, pChannels);
}

void WavDataOut::close(void)
{
    closeOutput();
}

void WavDataOut::putBit(int bitLength)
{
    // Writes a square wave of the given length
    int isOdd;
    int halfBitLength;

	bitcount++;
    halfBitLength = (int)(floor((float)bitLength)/2.0);
    isOdd = (int)(ceil((float)bitLength/2.0) - halfBitLength);

	int i;
    for (i=0;i<halfBitLength;i++)
        putSample(-100);
    if (isOdd)
	{
        putSample(0);
		i++;
	}
    for (;i<bitLength;i++)
        putSample(100);
}

void WavDataOut::putSample(int pAmplitude)
{
	for (int i=0; i<channels; i++)
	{
		WavFile::putSample(pAmplitude);
		if (sampleRate == 44100)
			WavFile::putSample(pAmplitude);
	}
}

void WavDataOut::putZeroBit()
{
	putBit(zeroBitLength);
}

void WavDataOut::putOneBit()
{
	putBit(oneBitLength);
}

void WavDataOut::putByte(unsigned char inByte)
{
    checkSum += inByte;
	for (int i=0; i<8; i++)
	{
		if (inByte >= 0x80)
			putBit(oneBitLength);
		else
			putBit(zeroBitLength);

		inByte = inByte << 1;
	}
}


