#include <cstdlib>
#include <string>
#include <iostream.h>
#include "ballyBinFile.h"
#include "Error.h"

void getParmString(int *argc, char ***argv, char *returnString, int maxLength)
{
    if (strlen((*argv)[0]) == 1)
    {
        strncpy(returnString, (*argv)[1], maxLength);
        --(*argc);
        (*++(*argv));
    } else
    {
        strncpy(returnString, **argv + 1, maxLength);
    }
    (**argv)[1] = 0;
}

int main(int argc, char *argv[]) {
    char binName[256]="", wavName[256]="";
    int binByteNum, loadByteNum;
    int c;
    char tapeName[256] = "";
    bool splitMultiLoad = false;
    ofstream ofsScBin;
    BallyBinFile inFile;
    
    binByteNum = 0;
    loadByteNum = 0;
    cout << "BallyBasic v1.3\n\n";
    cout << "Released July 27, 2002\n";
    cout << "Written by: Bob Colbert\n\n";
    cout.flush();
    
    if (argc == 1)
    {
        cout << "Usage:\n";
        cout << "   BallyBasic (.bin file name)]\n";
        
        return 1;
    }
    
    while (--argc > 0 && (*++argv)[0] == '-')
        while (c = *++argv[0])
            switch (c)
        {
    case 'm':
        splitMultiLoad = true;
        break;
    case 'w':
        getParmString(&argc, &argv, wavName, 255);
        break;
    default:
        cout << "Invalid option " << (char)c << "\n";
        return 1;
        break;
        }
        
        try
        {
            char basicLine[512];
            long lineNumber;
            inFile.open(argv[0],"r",2);
            inFile.processTag("OPEN");
//            inFile.getLoad(1);
//            cout << "Successfully retrieved load "<< 1 <<"!\n";
            while (inFile.getNextBasicLine(inFile.loadQue.front(), &lineNumber, basicLine))
                printf("%d %s\n", lineNumber, basicLine);
        }
        
        catch(Error::endOfFile)
        {
            cout << "Unexpected end of input reached\n";
            return 1;
        }
        
        catch(Error::badOutputFileName)
        {
            cout << "Invalid output .wav filename\n";
            return 1;
        }
        
        return 0;
}