#include "wavDataIn.h"

class ScDataFile : public binDataFile
{
    friend class ScWavFile;
public:
    ScDataFile();
    void open(char *pFileName);
    void write();
    double clearingToneLength;

protected:
	ofstream outFile;
    int fileOpen;
    unsigned char buffer[0x100][0x100];
    unsigned char bankByte[0x100];
    unsigned char checksum[0x100];
    unsigned char startLoByte;
    unsigned char startHiByte;
    unsigned char controlByte;
    unsigned char pageCount;
    unsigned char headerChecksum;
    unsigned char multiLoadByte;
    unsigned char speedLoByte;
    unsigned char speedHiByte;
};

class ScWavFile : public WavDataFile
{
public:
    ScWavFile();
	~ScWavFile();

    ScDataFile *load[10];
    int loadNumber;
    void open(char *inFile);
    unsigned int readByteHeader(void);
    bool decodeLoad(void);
    long decodeFooter(void);
    int convert(char *inFile);
    double decodeHeader(unsigned int headerEndVal);
    double clearingToneLength;

private:
    unsigned int byteHeader;
    unsigned int dataByte;
    unsigned int footerByte;
//    void syncFile(void);
//    void syncBits(void);
    void sync(void);
};

namespace Error
{
    struct badSecondByte { };
    struct loadConverted { };
    struct footerConverted { };
    struct badHeaderChecksum { };
    struct badPageChecksum { };
};
